/*
 *
 *  NExS Connection Library V2.0
 *  Copyright 1990, 1991, X Engineering Software Systems Corporation
 *  Copyright 1999, GreyTrout Software, Inc.
 *  All rights reserved
 *
 *  file: manager.c
 *
 * $Id: manager.c,v 1.2 91/08/13 18:48:46 tkm Exp $
 *
 */


#include	<stdio.h>
#include	<stdlib.h>
#include	<X11/Xlib.h>
#include	"nexs.h"

void nexs_notify_fn(displayID, nexs_window)
int displayID;
Window nexs_window;
    {
    int port;
    char *name;

    name = nexs_get_name(displayID, nexs_window);
    printf("New NExS window 0x%lx named \"%s\" on display %d...\n",
		(unsigned long) nexs_window, name, displayID);
    free(name);
    if ((port = mgr_connect(displayID, nexs_window, "Manager")))
	printf("Connected on port %d.\n", port);
    }

void close_notify_fn(port)
int port;
    {
    printf("Port number %d closed.\n", port);
    }

int main(argc, argv)
int argc;
char *argv[];
    {
    Display *display;
    Window *nexs_windows;
    int num_windows, displayID, i, port;
    char *name;

    if ((display = XOpenDisplay("")) == NULL)
	{
	printf("Can't open display!\n");
	exit(-1);
	}
    displayID = nexs_new_display(display);
    if (!mgr_manage_display(displayID))
	{
	printf("Can't manage display!\n");
	exit(-2);
	}
    mgr_set_nexs_notify(nexs_notify_fn);
    nexs_set_close_notify(close_notify_fn);
    printf("Scanning display %d for existing NExS windows...\n", displayID);
    if (!nexs_scan_display(displayID, &nexs_windows, &num_windows))
	{
	printf("Can't scan display!\n");
	exit(-3);
	}
    if (num_windows)
    	for (i = 0; i < num_windows; i++)
	    {
	    name = nexs_get_name(displayID, nexs_windows[i]);
	    printf("Found NExS window 0x%lx named \"%s\"",
						nexs_windows[i], name);
	    free(name);
	    if ((port = mgr_connect(displayID, nexs_windows[i], "Manager")))
		printf(" and connected on port %d.\n", port);
	    else
		printf(" but couldn't connect to it.\n");
	    }
    free(nexs_windows);
    printf("Now waiting for new NExS instances on display %d...\n", displayID);
    nexs_dispatcher(NULL);
	 return 0;
    }
