/*
 *
 *  NExS Connection Library
 *  Copyright 1990, 1991, X Engineering Software Systems Corporation
 *  Copyright 1999, GreyTrout Software, Inc.
 *  All rights reserved
 *
 *  file: parse.c
 *
 */

#include	<ctype.h>

static void translate_backslash_codes(char *s)
  {
  char *src, *dst, c1, c2;
  src = dst = s;
  while ((c1 = *src++))
    {
    if (c1 == '\\')
      {
      switch (c2 = *src++)
	{
	case 'n':		/* newline */
	  *dst++ = '\n';
	  break;
	default:
	  *dst++ = c2;
	}
      }
    else
      *dst++ = c1;
    }
  *dst = '\0';
  }


int parse_args(char *argv[], char *buf)
    {
    int argc = 0, in_string = 0, in_quote = 0, escape = 0, i;
    while (*buf)
        {
        if (*buf == '\"' && !escape)
            {
            if (in_string == 0)
                {
                in_string = in_quote = 1;
                *buf++ = '\0';
                if (*buf == '\"')       /* null string */
                    {
                    *buf = '\0';
                    in_string = in_quote = 0;
                    }
		if (*buf == '\\')
		    escape = 1;
		else
		    escape = 0;
                argv[argc++] = buf++;
		}
            else
                {
                *buf++ = '\0';
                in_string = in_quote = 0;
                }
            }
        else if (isspace(*buf) && !in_quote)
            {
            *buf++ = '\0';
            in_string = 0;
            }
        else if (!in_string)
            {
	    if (*buf == '\\')
		escape = 1;
	    else
		escape = 0;
            argv[argc++] = buf++;
            in_string = 1;
            }
        else
	    {
	    if (*buf == '\\')
		escape = 1;
	    else
		escape = 0;
            buf++;
	    }
        }
    for (i = 0; i < argc; i++)
	translate_backslash_codes(argv[i]);
    return argc;
    }

#ifdef PARSE_MAIN

int main(argc, argv)
int argc;
char *argv[];
    {
    int i;
    char buf[80];
    int argc;
    char *argv[20];
    while (fgets(buf, sizeof(buf), stdin))
	{
	argc = parse_args(argv, buf);
	for (i = 0; i < argc; i++)
	    printf("%d : \"%s\"\n", i, argv[i]);
	}
	 return 0;
    }

#endif
