/*
 *
 *  NExS Connection Library V2.0
 *  Copyright 1990, 1991, X Engineering Software Systems Corporation
 *  Copyright 1999, GreyTrout Software, Inc.
 *  All rights reserved
 *
 *  file: receiver.c
 *
 * $Id: receiver.c,v 1.2 91/08/13 18:48:50 tkm Exp $
 *
 */


#include	<stdio.h>
#include	<ctype.h>
#include	"nexs.h"

/*
  This program receives messages and returns them to the sender
  converted to upper case.

  To run this demo, start up "receiver" in the background and
  then run "sender".
*/

void close_notify_fn(port)
int port;
    {
    printf("Port %d closed, exiting...\n", port);
    exit(0);
    }

void recv_fn(port, buf)
int port;
char buf[15];
    {
    int i;
    for (i=0; i<15; i++)
	{
	if (islower(buf[i]))
	    buf[i] = toupper(buf[i]);
	}
    nexs_send_message(nexs_port, port, buf);
    }

int main(argc, argv)
int argc;
char *argv[];
    {
    int port;

    nexs_set_close_notify(close_notify_fn);
    nexs_set_receiver(recv_fn);
    port = nexs_open_connection("Receiver", 10);
    if (port == 0)
	{
	printf("Could not connect to NExS...");
	exit(0);
	}
    nexs_dispatcher(NULL);
	 return 0;
    }
