#include	<stdio.h>
#include	"nexs.h"

#define	COLUMN_LOC	1
#define	ROW_LOC		2
#define	RESULT_LOC	3

typedef struct	{
		int row, col;
		} Cell;

Cell column_var, row_var, result_var, tbl_top_left, tbl_bot_right;

long menu, row_button, col_button, result_button, tbl_button, go_button;

int port;


void get_location()
  {
  int r, c;
  char buf[80];

  nexs_get_location(port, &r, &c);
  switch (nexs_tag)
    {
    case COLUMN_LOC:
	column_var.row = r;
	column_var.col = c;
	sprintf(buf, "Col Var : %s%u", col_to_text(c), r);
	nexs_button_label(port, menu, col_button, buf);
	sprintf(buf, "Column Variable cell set to %s%u",
						col_to_text(c), r);
	nexs_display_message(port, buf);
	break;
    case ROW_LOC:
	row_var.row = r;
	row_var.col = c;
	sprintf(buf, "Row Var : %s%u", col_to_text(c), r);
	nexs_button_label(port, menu, row_button, buf);
	sprintf(buf, "Row Variable cell set to %s%u",
						col_to_text(c), r);
	nexs_display_message(port, buf);
	break;
    case RESULT_LOC:
	result_var.row = r;
	result_var.col = c;
	sprintf(buf, "Rslt Var : %s%u", col_to_text(c), r);
	nexs_button_label(port, menu, result_button, buf);
	sprintf(buf, "Result Variable cell set to %s%u",
						col_to_text(c), r);
	nexs_display_message(port, buf);
	break;
    }
  }


void get_table_loc()
  {
  char buf[80];
  Range temp;
  nexs_get_selected(port, &tbl_top_left.row, &tbl_top_left.col,
			  &tbl_bot_right.row, &tbl_bot_right.col);
  temp.r0 = tbl_top_left.row;
  temp.c0 = tbl_top_left.col;
  temp.r1 = tbl_bot_right.row;
  temp.c1 = tbl_bot_right.col;
  temp.flags = 0;
  sprintf(buf, "Tbl : %s", range_to_text(&temp));
  nexs_button_label(port, menu, tbl_button, buf);
  sprintf(buf, "Sensitivity Table range set to %s", range_to_text(&temp));
  nexs_display_message(port, buf);
  }

void make_table()
  {
  int r, c;
  Range recalc_ranges[2];
  double row_value, col_value, result;

  recalc_ranges[0].r0 = recalc_ranges[0].r1 = row_var.row;
  recalc_ranges[0].c0 = recalc_ranges[0].c1 = row_var.col;
  recalc_ranges[1].r0 = recalc_ranges[1].r1 = column_var.row;
  recalc_ranges[1].c0 = recalc_ranges[1].c1 = column_var.col;
  nexs_display_message(port, "Building sensitivity table...");
  for (c = tbl_top_left.col + 1; c <= tbl_bot_right.col; c++)
    for (r = tbl_top_left.row + 1; r <= tbl_bot_right.row; r++)
      {
      if (nexs_get_number(port, r, tbl_top_left.col, &row_value) &&
          nexs_get_number(port, tbl_top_left.row, c, &col_value))
	{
	nexs_store_number(port, row_var.row, row_var.col, row_value);
	nexs_store_number(port, column_var.row, column_var.col, col_value);
	nexs_recalc(port, 1, 2, recalc_ranges);
	if (nexs_get_number(port, result_var.row, result_var.col, &result))
	  nexs_store_number(port, r, c, result);
	}
      }
  nexs_display_message(port, "Sensitivity table done.");
  }

void close_fn()
  {
  exit(0);
  }

int main(argc, argv)
int argc;
char *argv[];
  {
  nexs_set_close_notify(close_fn);
  port = nexs_open_connection("SensAnal", 10);
  if (port == 0)
    {
    printf("could not connect to NExS after 10 seconds...\n");
    exit(1);
    }
  menu = nexs_create_menu(port, "SensAnal");
  row_button = nexs_create_button(port, menu, "Set Row Var",
				get_location, ROW_LOC);
  col_button = nexs_create_button(port, menu, "Set Column Var",
				get_location, COLUMN_LOC);
  result_button = nexs_create_button(port, menu, "Set Result Var",
				get_location, RESULT_LOC);
  tbl_button = nexs_create_button(port, menu, "Set Table Range",
				get_table_loc, 0);
  go_button = nexs_create_button(port, menu, "Build Table", make_table, 0);

  nexs_dispatcher(NULL);
  return 0;
  }
