/*
 *
 *  NExS Connection Library V2.0
 *  Copyright 1990, 1991, X Engineering Software Systems Corporation
 *  Copyright 1999, GreyTrout Software, Inc.
 *  All rights reserved
 *
 *  file: test1.c
 *
 * $Id: test1.c,v 1.1 91/08/13 18:49:09 tkm Exp $
 *
 */
 

#include	<stdio.h>
#include	"nexs.h"

int portID;

void b1_fn(), b2_fn(), b3_fn(), b4_fn();

long menu1ID, menu2ID, button1ID, button2ID, button3ID, button4ID;

void close_notify_fn(port)
int port;
    {
    fprintf(stderr, "Port number %d closed; exiting...\n", port);
    exit(0);
    }

void b1_fn()
    {
    if (menu2ID == 0)
	{
	menu2ID = nexs_create_menu(portID, "Menu 2");
	button3ID = nexs_create_button(portID, menu2ID, "Button 3", b3_fn, 0);
	button4ID = nexs_create_button(portID, menu2ID, "Button 4", b4_fn, 0);
	}
    }

void b2_fn()
    {
    nexs_delete_menu(portID, menu2ID);
    menu2ID = 0;
    }

void b3_fn()
    {
    double value;
    int r, c;
    Range recalc_range;

    recalc_range.r0 = recalc_range.r1 = 2;
    recalc_range.c0 = recalc_range.c1 = 2;

    if (nexs_get_number(portID, 2, 2, &value))
	nexs_store_number(portID, 2, 2, 2.0*value);
    else
	nexs_store_number(portID, 2, 2, -1.0);
    nexs_recalc(portID, 0, 1, &recalc_range);
    nexs_get_location(portID, &r, &c);
    printf("current NExS location: %d, %d\n", r, c);
    }

void b4_fn()
    {
    double value;
    Range recalc_range;

    recalc_range.r0 = recalc_range.r1 = 2;
    recalc_range.c0 = recalc_range.c1 = 2;

    if (nexs_get_number(portID, 2, 2, &value))
	nexs_store_number(portID, 2, 2, 0.5*value);
    else
	nexs_store_number(portID, 2, 2, -2.0);
    nexs_recalc(portID, 0, 1, &recalc_range);
    }

/*
  The main program stores some data in the sheet, does a goto, sets up a
  menu with a couple of buttons, and then waits for remote things to happen.
*/
int main(argc, argv)
int argc;
char *argv[];
    {
    int r, c;

    printf("establishing connection...\n");
    nexs_set_close_notify(close_notify_fn);
    portID = nexs_open_connection("My Program", 10);
    if (portID == 0)
	{
	printf("could not connect to NExS\n");
	exit(0);
	}
    else
	printf("connection established on port number %d\n", portID);
    for (r = 2; r < 12; r++)
	for (c = 1; c <= 10; c++)
	    nexs_store_number(portID, r, c, (double)(r+c));
    nexs_store_label(portID, 1, 1, "'");
    nexs_goto(portID, 1, 1);
    menu1ID = nexs_create_menu(portID, "Menu 1");
    button1ID = nexs_create_button(portID, menu1ID, "Button 1", b1_fn, 0);
    button2ID = nexs_create_button(portID, menu1ID, "Button 2", b2_fn, 0);

    nexs_dispatcher(NULL);
	 return 0;
    }
