/*
 *
 *  NExS Connection Library V2.0
 *  Copyright 1990, 1991, X Engineering Software Systems Corporation
 *  Copyright 1999, GreyTrout Software, Inc.
 *  All rights reserved
 *
 *  file: test2.c
 *
 * $Id: test2.c,v 1.1 91/08/13 18:49:44 tkm Exp $
 *
 */


#include	<stdio.h>
#include	<signal.h>
#include	<unistd.h>
#include	"nexs.h"

int portID, mon_row, mon_col, recalc_flag = 0;

void b1_fn(), b2_fn(), b3_fn(), b4_fn();

long menu1ID, button1ID, button2ID, button3ID, button4ID;

void doit()
    {
    static int n = 0;
    double sin();
    int net, disk;
    Range range;	/* defines range affecting partial recalculation */

    /* fake some data to monitor */

    net = 10000.0 * (sin(1.0 * n) + 1.0);
    disk = 1000.0 * (sin(1.5 * n) + 1.0);
    nexs_store_number(portID, mon_row+1, mon_col+1, (double) n++);
    nexs_store_number(portID, mon_row+2, mon_col+1, (double) net);
    nexs_store_number(portID, mon_row+3, mon_col+1, (double) disk);
    if (recalc_flag)
	{
	range.r0 = mon_row + 1;
	range.r1 = mon_row + 3;
	range.c0 = range.c1 = mon_col + 1;
	range.flags = 0;
	nexs_recalc(portID, 0, 1, &range);
	}
    nexs_flush();
    signal(SIGALRM, doit);
    alarm(5);
    }

void close_notify_fn(port)
int port;
    {
    fprintf(stderr, "Port number %d closed; exiting...\n", port);
    exit(0);
    }

void b1_fn()	/* start "monitoring" at current location */
    {
    nexs_get_location(portID, &mon_row, &mon_col);
    nexs_display_message(portID, "Monitoring Enabled");
    nexs_store_label(portID, mon_row, mon_col, "\'System Stats");
    nexs_store_label(portID, mon_row+1, mon_col, "\'Interval #");
    nexs_store_label(portID, mon_row+2, mon_col, "\'Network I/O:");
    nexs_store_label(portID, mon_row+2, mon_col+2, "\'packets");
    nexs_store_label(portID, mon_row+3, mon_col, "\'Disk I/O:");
    nexs_store_label(portID, mon_row+3, mon_col+2, "\'seeks");
    doit();
    }

void b2_fn()	/* stop "monitoring" */
    {
    alarm(0);
    nexs_display_message(portID, "Monitoring Disabled");
    }

void b3_fn()	/* Toggle recalculation flag */
    {
    if (recalc_flag)
	{
	recalc_flag = 0;
	nexs_display_message(portID, "Monitor recalculation set to manual");
	}
    else
	{
	recalc_flag = 1;
	nexs_display_message(portID, "Monitor recalculation set to automatic");
	}
    }

void b4_fn()	/* disconnect and exit */
    {
    nexs_close_connection(portID);
    exit(0);
    }

int main(argc, argv)
int argc;
char *argv[];
    {
    nexs_set_close_notify(close_notify_fn);
    portID = nexs_open_connection("SysMon", 10);
    if (portID == 0)
	{
	printf("could not connect to NExS after 10 seconds...\n");
	exit(0);
	}
    menu1ID = nexs_create_menu(portID, "Monitor");
    button1ID = nexs_create_button(portID, menu1ID, "Start Monitor", b1_fn, 0);
    button2ID = nexs_create_button(portID, menu1ID, "Stop Monitor", b2_fn, 0);
    button3ID = nexs_create_button(portID, menu1ID, "Toggle Recalc", b3_fn, 0);
    button4ID = nexs_create_button(portID, menu1ID, "Disconnect", b4_fn, 0);

    nexs_dispatcher(NULL);
	 return 0;
    }
