/*
 *
 *  NExS Connection Library V2.0
 *  Copyright 1990, 1991, X Engineering Software Systems Corporation
 *  Copyright 1999, GreyTrout Software, Inc.
 *  All rights reserved
 *
 *  file: test4.c
 *
 * $Id: test4.c,v 1.1 91/08/13 18:49:51 tkm Exp $
 *
 */


#include	<stdio.h>
#include	<signal.h>
#include "nexs.h"

int portID;

void b1_fn(), b2_fn(), b3_fn();

long menu1ID, button1ID, button2ID, button3ID;

void close_notify_fn(port)
int port;
    {
    fprintf(stderr, "Port number %d closed; exiting...\n", port);
    exit(0);
    }

void b1_fn()	/* prompt for range */
    {
    int r0, r1, c0, c1;
    nexs_display_message(portID, "Please Select Range...");
    if (nexs_get_range(portID, &r0, &c0, &r1, &c1))
	{
	printf("r0 = %d, c0 = %d, r1 = %d, c1 = %d\n", r0, c0, r1, c1);
	nexs_display_message(portID, "");
	}
    else
	nexs_display_message(portID, "Operation canceled...");
    }

void b2_fn()	/* get current selected range */
    {
    int r0, r1, c0, c1;
    nexs_get_selected(portID, &r0, &c0, &r1, &c1);
    printf("r0 = %d, c0 = %d, r1 = %d, c1 = %d\n", r0, c0, r1, c1);
    }

void b3_fn()	/* disconnect and exit */
    {
    nexs_close_connection(portID);
    exit(0);
    }

int main(argc, argv)
int argc;
char *argv[];
	{
    nexs_set_close_notify(close_notify_fn);
    portID = nexs_open_connection("Get Range", 10);
    if (portID == 0)
	{
	printf("could not connect to NExS after 10 seconds...\n");
	exit(0);
	}
    menu1ID = nexs_create_menu(portID, "Get Range");
    button1ID = nexs_create_button(portID, menu1ID, "Select Range", b1_fn, 0);
    button2ID = nexs_create_button(portID, menu1ID, "Get Selected", b2_fn, 0);
    button3ID = nexs_create_button(portID, menu1ID, "Disconnect", b3_fn, 0);

    nexs_dispatcher(NULL);
	 return 0;
    }
