/*
 *
 *  NExS Connection Library V2.0
 *  Copyright 1990, 1991, X Engineering Software Systems Corporation
 *  Copyright 1999, GreyTrout Software, Inc.
 *  All rights reserved
 *
 *  file: test6.c
 *
 * $Id: test6.c,v 1.2 91/08/13 18:49:57 tkm Exp $
 *
 */


#include	<stdio.h>
#include	<stdlib.h>
#include	"nexs.h"

int portID;

char buffer[200];

long menu1ID, button1ID, button2ID, button3ID,
     button4ID, button5ID, button6ID, button7ID,
     button8ID, button9ID, button10ID, button11ID,
     button12ID, button13ID;

void close_notify_fn(port)
int port;
    {
    fprintf(stderr, "Port number %d closed; exiting...\n", port);
    exit(0);
    }

void d_fn(status, dialog_text)
int status;
char *dialog_text;
    {
    switch (status)
	{
	case NEXS_DIALOG_BUSY:
	    printf("NExS Dialog box busy...\n");
	    break;
	case NEXS_DIALOG_OK:
	    strcpy(buffer, dialog_text);
	    printf("NExS Dialog text = \"%s\"\n", buffer);
	    break;
	case NEXS_DIALOG_CANCELED:
	    printf("NExS Dialog canceled...\n");
	    break;
	}
    }

void b1_fn()
    {
    nexs_dialog(portID, "This is the Prompt!", "This is the default...", d_fn);
    nexs_get_input(portID, "Please enter data...", buffer, 200);
    }

void b2_fn()
    {
    int r, c, status;
    double value;
    char *strptr;

    nexs_get_location(portID, &r, &c);
    status = nexs_evaluate_cell(portID, r, c, &value, &strptr);
    switch (status)
	{
	case NEXS_EMPTY:
	    printf("Cell is empty\n");
	    break;
	case NEXS_NUMBER:
	    printf("The numeric value is %g\n", value);
	    break;
	case NEXS_STRING:
	    printf("The string value is \"%s\"\n", strptr);
	    free(strptr);
	    break;
	}
    }

void b3_fn()
    {
    int r, c, status;
    double value;
    char *strptr;

    nexs_get_location(portID, &r, &c);
    status = nexs_get_value(portID, r, c, &value, &strptr);
    switch (status)
	{
	case NEXS_EMPTY:
	    printf("Cell is empty\n");
	    break;
	case NEXS_NUMBER:
	    printf("The numeric value is %g\n", value);
	    break;
	case NEXS_STRING:
	    printf("The string value is \"%s\"\n", strptr);
	    free(strptr);
	    break;
	}
    }

void b4_fn()
    {
    int r, c, status;
    char *strptr;

    nexs_get_location(portID, &r, &c);
    status = nexs_get_formula(portID, r, c, &strptr);
    switch (status)
	{
	case NEXS_EMPTY:
	    printf("Cell is empty\n");
	    break;
	case NEXS_FORMULA:
	    printf("Formula is \"%s\"\n", strptr);
	    free(strptr);
	    break;
	case NEXS_LABEL:
	    printf("Label is \"%s\"\n", strptr);
	    free(strptr);
	    break;
	}
    }

void b5_fn()
    {
    int r, c;

    nexs_get_location(portID, &r, &c);
    nexs_store_formula(portID, r, c, buffer);	/* from dialog box */
    }

void b6_fn()
    {
    int status;
    double value;
    char *strptr;

    status = nexs_evaluate_expr(portID, buffer, &value, &strptr);
    switch (status)
	{
	case NEXS_EMPTY:
	    printf("Expression is not valid\n");
	    break;
	case NEXS_NUMBER:
	    printf("The numeric value is %g\n", value);
	    break;
	case NEXS_STRING:
	    printf("The string value is \"%s\"\n", strptr);
	    free(strptr);
	    break;
	}
    }

void b7_fn()
    {
    int r, c, status;
    double value;

    nexs_get_location(portID, &r, &c);
    status = nexs_get_number(portID, r, c, &value);
    switch (status)
	{
	case NEXS_EMPTY:
	    printf("Cell does not contain a number (%g returned)\n", value);
	    break;
	case NEXS_NUMBER:
	    printf("The numeric value is %g\n", value);
	    break;
	}
    }

void b8_fn()
    {
    int r, c, status;
    char *strptr;

    nexs_get_location(portID, &r, &c);
    status = nexs_get_string(portID, r, c, &strptr);
    switch (status)
	{
	case NEXS_EMPTY:
	    printf("Cell does not contain a string (\"%s\" returned)\n",
									strptr);
	    break;
	case NEXS_STRING:
	    printf("The string value is \"%s\"\n", strptr);
	    break;
	}
    free(strptr);
    }

void b9_fn()
    {
    int r, c, status;

    nexs_get_location(portID, &r, &c);
    status = nexs_evaluate_constraint(portID, r, c);
    if (status)
	printf("Constraint Violation!\n");
    }

void b10_fn()
    {
    int status;

    status = nexs_recalc_constraints(portID);
    printf("There were %d constraint violations\n", status);
    }

void exit_fn()
    {
    nexs_close_connection(portID);
    exit(0);
    }

int main(argc, argv)
int argc;
char *argv[];
    {
    printf("establishing connection...\n");
    nexs_set_close_notify(close_notify_fn);
    portID = nexs_open_connection("Test 6", 10);
    if (portID == 0)
	{
	printf("could not connect to NExS\n");
	exit(0);
	}
    menu1ID = nexs_create_menu(portID, "Test 6");
    button1ID = nexs_create_button(portID, menu1ID, "Popup Dialog", b1_fn, 0);
    button2ID = nexs_create_button(portID, menu1ID, "Evaluate Cell", b2_fn, 0);
    button3ID = nexs_create_button(portID, menu1ID, "Get Value", b3_fn, 0);
    button4ID = nexs_create_button(portID, menu1ID, "Get Formula", b4_fn, 0);
    button5ID = nexs_create_button(portID, menu1ID, "Put Formula", b5_fn, 0);
    button6ID = nexs_create_button(portID, menu1ID, "Eval Expression", b6_fn, 0);
    button7ID = nexs_create_button(portID, menu1ID, "Get Number", b7_fn, 0);
    button8ID = nexs_create_button(portID, menu1ID, "Get String", b8_fn, 0);
    button9ID = nexs_create_button(portID, menu1ID, "Eval Constraint", b9_fn, 0);
    button10ID = nexs_create_button(portID, menu1ID, "Recalc Constr", b10_fn, 0);
    button11ID = nexs_create_button(portID, menu1ID, "Dismiss", exit_fn, 0);

    nexs_dispatcher(NULL);
	 return 0;
    }
