/*
 *
 *  NExS Connection Library V2.0
 *  Copyright 1990, 1991, X Engineering Software Systems Corporation
 *  Copyright 1999, GreyTrout Software, Inc.
 *  All rights reserved
 *
 *  file: test7.c
 *
 * $Id: test7.c,v 1.1 91/08/13 18:50:13 tkm Exp $
 *
 */


#include	<stdio.h>
#include	"nexs.h"

int portID;

void b1_fn(), b2_fn();

long menu1ID, button1ID, button2ID;

void close_notify_fn(port)
int port;
    {
    fprintf(stderr, "Port number %d closed; exiting...\n", port);
    exit(0);
    }

void b1_fn()
    {
    int rmin, cmin, rmax, cmax;

    if (nexs_get_extent(portID, &rmin, &cmin, &rmax, &cmax))
	printf("Sheet extents: rmin = %d, cmin = %d, rmax = %d, cmax = %d\n",
		rmin, cmin, rmax, cmax);
    else
	printf("The sheet is empty!\n");
    }

void b2_fn()
    {
    int r0, c0, r1, c1, r, c, status;

    nexs_get_selected(portID, &r0, &c0, &r1, &c1);
    if (r0 == r1 && c0 == c1)	/* search entire sheet */
	status = nexs_find_label(portID, "foo", &r, &c);
    else
	status = nexs_find_label_in_range(portID, "foo",
						r0, c0, r1, c1, &r, &c);
    if (status)
	printf("\"foo\" found at r = %d, c = %d\n", r, c);
    else
	printf("\"foo\" not found\n");
    }

int main(argc, argv)
int argc;
char *argv[];
    {
    printf("establishing connection...\n");
    nexs_set_close_notify(close_notify_fn);
    portID = nexs_open_connection("Test 7", 10);
    if (portID == 0)
	{
	printf("could not connect to NExS\n");
	exit(0);
	}
    menu1ID = nexs_create_menu(portID, "Test 7");
    button1ID = nexs_create_button(portID, menu1ID, "Get Extent", b1_fn, 0);
    button2ID = nexs_create_button(portID, menu1ID, "Find \"foo\"", b2_fn, 0);

    nexs_dispatcher(NULL);
	 return 0;
    }
