/*
 *
 *  NExS Connection Library V2.0
 *  Copyright 1990, 1991, X Engineering Software Systems Corporation
 *  Copyright 1999, GreyTrout Software, Inc.
 *  All rights reserved
 *
 *  file: test8.c
 *
 * $Id: test8.c,v 1.2 91/08/13 18:50:16 tkm Exp $
 *
 */


#include	<stdio.h>
#include	<signal.h>
#include	<math.h>
#include <unistd.h>
#include	"nexs.h"

#define	N_ROWS		10
#define	ALARM_RATE	3	/* send new data every ALARM_RATE seconds */

#define	DATA(x)	(10000.0 * (sin(1.0 * (x)) + 1.0))

int portID, mon_row, mon_col, recalc_flag = 0;

int count, direction;

void b1_fn(), b2_fn(), b3_fn(), b4_fn();

long menu1ID, button1ID, button2ID, button3ID, button4ID;

void doit()
    {
    Range range;	/* defines range affecting partial recalculation */

    /* fake some data to scroll */

    nexs_scroll_range(portID, mon_row, mon_col,
			mon_row + N_ROWS-1, mon_col + 1, direction);

    if (direction == NEXS_SCROLL_UP)	/* put new value in bottom row */
	{
	nexs_store_number(portID, mon_row + N_ROWS-1,
					mon_col, (double) count++);
	nexs_store_number(portID, mon_row + N_ROWS-1,
					mon_col + 1, DATA(count));
	}
    else				/* put new value in top row */
	{
	nexs_store_number(portID, mon_row, mon_col, (double) count++);
	nexs_store_number(portID, mon_row, mon_col + 1, DATA(count));
	}

    if (recalc_flag)
	{
	range.r0 = mon_row;
	range.r1 = mon_row + N_ROWS;
	range.c0 = mon_col;
	range.c1 = mon_col + 1;
	range.flags = 0;
	nexs_recalc(portID, 0, 1, &range);
	}
    nexs_flush();
    signal(SIGALRM, doit);
    alarm(ALARM_RATE);
    }

void close_notify_fn(port)
int port;
    {
    fprintf(stderr, "Port number %d closed; exiting...\n", port);
    exit(0);
    }

void b1_fn()
    {
    int i;

    nexs_get_location(portID, &mon_row, &mon_col);
    nexs_display_message(portID, "Upward Scrolling Started");
    count = 0;
    direction = NEXS_SCROLL_UP;
    for (i=0; i<N_ROWS; i++)
	{
        nexs_store_number(portID, mon_row + i, mon_col, (double) count++);
        nexs_store_number(portID, mon_row + i, mon_col + 1, DATA(count));
	}
    doit();
    }

void b2_fn()
    {
    int i;

    nexs_get_location(portID, &mon_row, &mon_col);
    nexs_display_message(portID, "Downward Scrolling Started");
    count = 0;
    direction = NEXS_SCROLL_DOWN;
    for (i=N_ROWS-1; i>=0; i--)
	{
        nexs_store_number(portID, mon_row + i, mon_col, (double) count++);
        nexs_store_number(portID, mon_row + i, mon_col + 1, DATA(count));
	}
    doit();
    }

void b3_fn()	/* Toggle recalculation flag */
    {
    if (recalc_flag)
	{
	recalc_flag = 0;
	nexs_display_message(portID, "Monitor recalculation set to manual");
	}
    else
	{
	recalc_flag = 1;
	nexs_display_message(portID, "Monitor recalculation set to automatic");
	}
    }

void b4_fn()	/* disconnect and exit */
    {
    nexs_close_connection(portID);
    exit(0);
    }

int main(argc, argv)
int argc;
char *argv[];
	{
    nexs_set_close_notify(close_notify_fn);
    portID = nexs_open_connection("Test 8", 10);
    if (portID == 0)
	{
	printf("could not connect to NExS after 10 seconds...\n");
	exit(0);
	}
    menu1ID = nexs_create_menu(portID, "Test 8");
    button1ID = nexs_create_button(portID, menu1ID, "Start Up", b1_fn, 0);
    button2ID = nexs_create_button(portID, menu1ID, "Start Down", b2_fn, 0);
    button3ID = nexs_create_button(portID, menu1ID, "Toggle Recalc", b3_fn, 0);
    button4ID = nexs_create_button(portID, menu1ID, "Disconnect", b4_fn, 0);

    nexs_dispatcher(NULL);
	 return 0;
    }
