/*
 *
 *  NExS Connection Library V2.0
 *  Copyright 1990, 1991, X Engineering Software Systems Corporation
 *  Copyright 1999, GreyTrout Software, Inc.
 *  All rights reserved
 *
 *  file: test9.c
 *
 * $Id: test9.c,v 1.1 91/08/13 19:01:12 tkm Exp $
 *
 */


#include	<stdio.h>
#include	"nexs.h"

int portID;

char buffer[200];

long menu1ID, button1ID, button2ID, button3ID,
     button4ID, button5ID, button6ID;

void close_notify_fn(port)
int port;
    {
    fprintf(stderr, "Port number %d closed; exiting...\n", port);
    exit(0);
    }

void d_fn(status, dialog_text)
int status;
char *dialog_text;
    {
    switch (status)
	{
	case NEXS_DIALOG_BUSY:
	    printf("NExS Dialog box busy...\n");
	    break;
	case NEXS_DIALOG_OK:
	    strcpy(buffer, dialog_text);
	    printf("NExS Dialog text = \"%s\"\n", buffer);
	    break;
	case NEXS_DIALOG_CANCELED:
	    printf("NExS Dialog canceled...\n");
	    break;
	}
    }

void b1_fn()
    {
    nexs_dialog(portID, "Enter Range Name", "", d_fn);
    }

void b2_fn()	/* name relative */
    {
    int r0, c0, r1, c1;
    Range range;

    nexs_get_selected(portID, &r0, &c0, &r1, &c1);
    range.r0 = r0;
    range.c0 = c0;
    range.r1 = r1;
    range.c1 = c1;
    range.flags = 0;
    if (r0 == r1 && c0 == c1) range.flags |= CELL_ONLY;
    if (!nexs_define_name(portID, &range, buffer))
	printf("Could not define named range\n");
    }

void b3_fn()	/* name absolute */
    {
    int r0, c0, r1, c1;
    Range range;

    nexs_get_selected(portID, &r0, &c0, &r1, &c1);
    range.r0 = r0;
    range.c0 = c0;
    range.r1 = r1;
    range.c1 = c1;
    range.flags = ABS_R0 | ABS_C0 | ABS_C1 | ABS_R1;
    if (r0 == r1 && c0 == c1) range.flags |= CELL_ONLY;
    if (!nexs_define_name(portID, &range, buffer))
	printf("Could not define named range\n");
    }

void b4_fn()	/* resolve name in buffer */
    {
    Range range;

    if (!nexs_resolve_name(portID, &range, buffer))
	printf("Could not define named range\n");
    else
	printf("r0 = %d, c0 = %d, r1 = %d, c1 = %d, flags = %d\n",
		range.r0, range.c0, range.r1, range.c1, range.flags);
    }

void b5_fn()	/* delete name */
    {
    nexs_delete_name(portID, buffer);
    }

void exit_fn()
    {
    nexs_close_connection(portID);
    exit(0);
    }

int main(argc, argv)
int argc;
char *argv[];
    {
    printf("establishing connection...\n");
    nexs_set_close_notify(close_notify_fn);
    portID = nexs_open_connection("Test 9", 10);
    if (portID == 0)
	{
	printf("could not connect to NExS\n");
	exit(0);
	}
    menu1ID = nexs_create_menu(portID, "Test 9");
    button1ID = nexs_create_button(portID, menu1ID, "Popup Dialog", b1_fn, 0);
    button2ID = nexs_create_button(portID, menu1ID, "Name Relative", b2_fn, 0);
    button3ID = nexs_create_button(portID, menu1ID, "Name Absolute", b3_fn, 0);
    button4ID = nexs_create_button(portID, menu1ID, "Resolve Name", b4_fn, 0);
    button5ID = nexs_create_button(portID, menu1ID, "Delete Name", b5_fn, 0);
    button6ID = nexs_create_button(portID, menu1ID, "Dismiss", exit_fn, 0);

    nexs_dispatcher(NULL);
	 return 0;
    }
