#!/bin/sh
# the next line restarts using tclNExS \
exec tclNExS "$0" "$@"

# We don't want a window:
wm withdraw .

# process command line arguments
if {( $argc < 1 )} then {
  puts stderr "Usage: $argv0 <filename>
       (where <filename> is the name of an NExS .xs3 file)"
  exit 1
}

set nexspid [exec nexs -con a -iconic &]
nexs connect p1 -name printxs
foreach file $argv {
  p1 clear_sheet
  p1 read_file $file
  p1 export -from [con get_extent] -to [file rootname $file].csv -type csv
}

exec kill -HUP $nexspid

exit 0
