#!/bin/sh
# the next line restarts using tclNExS \
exec tclNExS "$0" "$@"

# This example demonstrates the creation of a user-defined function
# @MYFUNC(arg1,arg2) which computes the result 2 * arg1 + arg2.
#
# In the current implementation of tclNExS we can install up to 256
# functions from each tclNExS process.
#
# TKM 1/19/97
#

proc myfunc {arg1 arg2} {
  global nexs_connection

# Check arg1 and arg2 to see if they look like cell addresses.  If so,
# retrieve a number from the cell.

  if {[regexp {^\$?[A-Z]} $arg1]} {
    set arg1 [$nexs_connection get_number $arg1]
  }
  if {[regexp {^\$?[A-Z]} $arg2]} {
    set arg2 [$nexs_connection get_number $arg2]
  }

# Compute the result and return it

  return [expr 2*$arg1 + $arg2]
}

proc foo {} {
  return 76
}


#
# This is the "main" program.  Suppress the "wish" window, connect to NExS,
# and install the function.  (You can use this as a boilerplate.)
#

# Suppress the "wish" window:

wm withdraw .

# Establish the connection to NExS and set up for graceful failure:

if [catch {nexs connect port -name myfunc -timeout 10 \
  -closecommand {puts stderr "Port number %P closed; exiting...\n"; destroy .}
  }] {
  puts stderr "Couldn't connect after 10 seconds"
  destroy .
}

# Install the function @MYFUNC(arg1,arg2):

port install_function "myfunc" myfunc

port install_function "foo" foo
