#!/bin/sh
# the next line restarts using tclNExS \
exec tclNExS "$0" "$@"

# Print .xs3 files in "batch" mode.

# We don't want a "wish" window:
  wm withdraw .

# Make sure one or more .xs3 file names are specified on the command line:
  if {( $argc < 1 )} then {
    puts stderr "Usage: $argv0 <filename>...
	 (where <filename>... is one or more NExS .xs3 files)"
    exit 1
  }

# Launch NExS with API connections enabled, iconified:
  set nexspid [exec nexs -con a -iconic &]

# Set up a connection named p1 to the newly launched NExS:
  nexs connect p1 -name printxs3

# For each .xs3 file clear the worksheet, read the file, and print it.
  foreach file $argv {
    p1 clear_sheet
    p1 read_file $file
    p1 print [con get_extent] -type ps
  }

# Shut down NExS and exit the script:
exec kill -HUP $nexspid
exit 0
