/*
 * $Id: nexsCOCloseCmd.c,v 1.1 1995/11/23 20:27:58 tkm Exp $
 */

static char copyright []
= "$Id: nexsCOCloseCmd.c,v 1.1 1995/11/23 20:27:58 tkm Exp $\n\
   Copyright (c) 1992 General Electric.  All rights reserved.\n\
   Copyright (C) 1994 Applied Information Systems.  All rights reserved.";

/*
 *   Permission to use, copy, modify, and distribute this
 *   software and its documentation for any purpose and without
 *   fee is hereby granted, provided that the above copyright
 *   notice appear in all copies and that both that copyright
 *   notice and this permission notice appear in supporting
 *   documentation, and that the name of General Electric not be used in
 *   advertising or publicity pertaining to distribution of the
 *   software without specific, written prior permission.
 *   General Electric makes no representations about the suitability of
 *   this software for any purpose.  It is provided "as is"
 *   without express or implied warranty.
 *
 *   This work was supported by the DARPA Initiative in Concurrent
 *   Engineering (DICE) through DARPA Contract MDA972-88-C-0047.
 *
 * nexsCOCloseCmd.c --
 * 
 *	Handle the `close' command on an NExS connection object
 */

char RCSid_nexsCOCloseCmd_c []
= "$Id: nexsCOCloseCmd.c,v 1.1 1995/11/23 20:27:58 tkm Exp $";
/* $Log: nexsCOCloseCmd.c,v $
 * Revision 1.1  1995/11/23 20:27:58  tkm
 * Initial revision
 *
 * Revision 1.3  1994/11/09  14:36:46  johnsonm
 * *** empty log message ***
 *
 * Revision 1.2  1994/08/25  21:02:27  johnsonm
 * Changed RCS information.
 *
 * Revision 1.1  1994/08/25  20:59:30  johnsonm
 * Initial revision
 *
 */

#include <tcl.h>
#include <tk.h>
#include "tclNExSInt.h"

int
NExSConnObj_close_cmd (clientData, interp, argc, argv)
     ClientData clientData;
     Tcl_Interp * interp;
     int argc;
     char * * argv;
{
  NExSConnection * conn = (NExSConnection *) clientData;

  if (argc != 1) {
    Tcl_AppendResult (interp, "wrong # args, should be \"", argv [-1],
		      " ", argv [0], "\"", (char *) NULL);
    return TCL_ERROR;
  }

  Tcl_DeleteCommand (interp, conn -> objectName);

  return TCL_OK;
}
