static char copyright []
= "$Id: nexsCOMessage.c,v 1.1 1995/11/23 20:27:58 tkm Exp $\n\
   Copyright (c) 1992 General Electric.  All rights reserved.";

/*
 *   Permission to use, copy, modify, and distribute this
 *   software and its documentation for any purpose and without
 *   fee is hereby granted, provided that the above copyright
 *   notice appear in all copies and that both that copyright
 *   notice and this permission notice appear in supporting
 *   documentation, and that the name of General Electric not be used in
 *   advertising or publicity pertaining to distribution of the
 *   software without specific, written prior permission.
 *   General Electric makes no representations about the suitability of
 *   this software for any purpose.  It is provided "as is"
 *   without express or implied warranty.
 *
 *   This work was supported by the DARPA Initiative in Concurrent
 *   Engineering (DICE) through DARPA Contract MDA972-88-C-0047.
 *
 * $Log: nexsCOMessage.c,v $
 * Revision 1.1  1995/11/23 20:27:58  tkm
 * Initial revision
 *
 * Revision 1.1  1994/08/26  13:28:35  johnsonm
 * Initial revision
 *
 *
 * Old log:
 * Revision 1.2  1994/02/28  20:42:23  kennykb
 * Removed #includes that are now obtained from tclNExSInt.h
 *
 * Revision 1.1  1992/10/09  19:01:39  kennykb
 * Initial revision
 *
 *
 * nexsCOMessageCmd.c --
 * 
 *	Handle the `message' command on an NExS connection object
 */

#include "tclNExSInt.h"

/*
 * NExSConnObj_message_cmd --
 *
 *	Handle the `message' command on an NExS connection object
 *
 * Syntax:
 *
 *	connectionName message text
 *
 * Where:
 *	connectionName is the name of an NExS connection object.
 *	text is the text of the message to display
 *
 * Results:
 *	Returns a standard Tcl result.
 */

int
NExSConnObj_message_cmd (clientData, interp, argc, argv)
     ClientData clientData;
     Tcl_Interp * interp;
     int argc;
     char * * argv;
{
  NExSConnection * conn = (NExSConnection *) clientData;

  char * message;

  if (argc < 2) {
    Tcl_AppendResult (interp, "wrong # args, should be \"", argv [-1],
		      " ", argv [0], " text\"", (char *) NULL);
    return TCL_ERROR;
  }

  message = Tcl_Concat (argc-1, argv+1);

  nexs_display_message (conn -> port, message);

  (void) ckfree (message);

  return TCL_OK;
}
