static char rcsid[] = "$Id: nexsCancelGraph.c,v 1.1 1998/03/23 02:58:36 tkm Exp $";

/*------------------------------------------------------------*
|                                                             |
| Interface for NExS  gtaph API     .                         |
| Author:	Damir Delija                                  |
|               University Computing Center, SRCE             |
| Date:         Wed Mar 12 1997                               |
|               Copyright (c) 1997,  Damir Delija             |
|                                                             |
*--------------------Procedure Description--------------------*
| nexs_cancel_graph.c D. Delija 12/03/97                      |
|                                                             |
| int nexs_cancel_graph(int port, int gid);                   |
|                                                             |
|        The graph specified by "gid" is unmapped from the    |
|        display. The graph may be subsequently redisplayed   |
|        by calling nexs_display_graph() or by selecting it   |
|        from the NExS Graph menu.  Returns 1 if successful,  |
|        0 otherwise.                                         |
|                                                             |
*----------------Modification Audit/Change Log----------------*
| Rev  Sar                                                    |
| No   Code  Date      Rellvl  Mod  Description               |
| --   ----- --------  ------  ---  --------------------------|
|                                                             |
*-------------------------------------------------------------*/

/*
 * $Log: nexsCancelGraph.c,v $
 * Revision 1.1  1998/03/23 02:58:36  tkm
 * Initial revision
 *
 */


#include "tclNExSInt.h"

int NExSConnObj_cancel_graph_cmd(
        void *clientData,
        Tcl_Interp *interp,
        int argc,
        char **argv)
{

NExSConnection * conn = (NExSConnection *) clientData;
int port=0;
int gid=0;


	if (argc != 2 ) { 
		 Tcl_AppendResult( interp,
                "wrong # args:  ", argv[0],
                (char*) NULL);
                return (TCL_ERROR);
	}

	Tcl_GetInt(interp, argv[1],&gid);



	if ( nexs_cancel_graph ( conn->port, gid) ) {
		return TCL_OK;
	}  
	return TCL_ERROR;



}


