static char rcsid[] = "$Id: nexsGgenChar.c,v 1.1 1998/03/23 02:58:36 tkm Exp $";

/*------------------------------------------------------------*
|                                                             |
| Interface for NExS  gtaph API     .                         |
| Author:	Damir Delija                                  |
|               University Computing Center, SRCE             |
| Date:         Wed Mar 12 1997                               |
|               Copyright (c) 1997,  Damir Delija             |
|                                                             |
*--------------------Procedure Description--------------------*
| nexs_ggen_graph.c D. Delija 12/03/97                        |
|                                                             |
| int nexs_ggen_char(int port, int gid, GrGenChar *gchar,     |
| int mask);                                                  |
|                                                             |
|       Gets and/or sets all fields on the "General           |
|       Characteristics" dialog of the graph specified        |
|       by "gid". To set fields on the graph's General        |
|       Characteristics dialog, the desired values            |
|       should be stored in the "gchar" structure and the     |
|       corresponding bits in "mask" should be set to 1.      |
|       See "nexs.h" for details of the GrGenChar structure   |
|       and mask. Upon return, the "gchar" structure          |
|       will be filled in with all current values of the      |
|       graph's General Characteristics dialog. Note that     |
|       the "title_text" member of "gchar" is dynamically     |
|       allocated and should be freed when no longer needed   |
|       by the client. Returns 1 if successful, 0 otherwise.  |
|                                                             |
*----------------Modification Audit/Change Log----------------*
| Rev  Sar                                                    |
| No   Code  Date      Rellvl  Mod  Description               |
| --   ----- --------  ------  ---  --------------------------|
|                                                             |
*-------------------------------------------------------------*/

/*
 * $Log: nexsGgenChar.c,v $
 * Revision 1.1  1998/03/23 02:58:36  tkm
 * Initial revision
 *
 */


#include "tclNExSInt.h"

int ggenDO ( int argc, char **argv, int port, int gid);

int NExSConnObj_ggen_char_cmd(
        void *clientData,
        Tcl_Interp *interp,
        int argc,
        char **argv)
{
NExSConnection * conn = (NExSConnection *) clientData;
int port=0;
int gid=0;

	if (argc < 2 ) {
		return TCL_ERROR;
	}


	Tcl_GetInt(interp, argv[1],&gid);
	port = conn->port;
	return ggenDO(argc-2,argv+2,gid,port);
}
/*
part of gs*c fucntion
simple cut of and parse the arguments up to now one by one option
is set, i future some kind of cycling will be added
*/

int ggenDO ( 
        int argc,
        char **argv,
	int port,
	int gid) {

    unsigned long mask=0;
    GrGenChar genchar;

/*
 * Start of Graphics Commands
 */
	if (!strcmp(argv[0], "-graphtype"))
	    {
	    if (argc > 1)
		{
		mask = GR_TYPE;
		genchar.graph_type = atoi(argv[1]);
		}
	    }
	else if (!strcmp(argv[0], "-shade"))
	    {
	    if (argc > 1)
		{
		mask = SURFACE_SHADE;
		genchar.surface_shade = atoi(argv[1]);
		}
	    }
	else if (!strcmp(argv[0], "-update"))
	    {
	    if (argc > 1)
		{
		mask = RECALC_UPDATE;
		genchar.recalc_update = atoi(argv[1]);
		}
	    }
	else if (!strcmp(argv[0], "-legend"))
	    {
	    if (argc > 1)
		{
		mask = DISP_LEGEND;
		genchar.disp_legend = atoi(argv[1]);
		}
	    }
	else if (!strcmp(argv[0], "-titlefont"))
	    {
	    if (argc > 1)
		{
		mask = TITLE_FONT;
		genchar.title_font = atoi(argv[1]);
		}
	    }
	else if (!strcmp(argv[0], "-graphtitle"))
	    {
	    if (argc > 1)
		{
		mask = TITLE_TEXT;
		genchar.title_text = argv[1];
		}
	    }

	    if (!nexs_ggen_char(port, gid, &genchar, mask))
		{
			return TCL_OK;
		}
	return TCL_ERROR;
}



