static char rcsid[] = "$Id: nexsGraphGeometry.c,v 1.1 1998/03/23 02:58:36 tkm Exp $";

/*------------------------------------------------------------*
|                                                             |
| Interface for NExS  gtaph API     .                         |
| Author:	Damir Delija                                  |
|               University Computing Center, SRCE             |
| Date:         Wed Mar 12 1997                               |
|               Copyright (c) 1997,  Damir Delija             |
|                                                             |
*--------------------Procedure Description--------------------*
| int nexs_graph_geometry(int port, int gid, GrGeometry       |
| ggeom, int mask);                                           |
|                                                             |
|       Gets and/or sets the screen coordinates and           |
|       window size for the graph window specified by         |
|       "gid". See "nexs.h" for details on the GrGeometry     |
|       structure. Note that this function does not           |
|       correspond with any NExS dialog; moving and resizing  |
|       windows are normally handled by interaction with      |
|       the Window Manager. Note also that the values set     |
|       by this function may be overidden by the Window       |
|       Manager. Returns 1 if successful, 0 otherwise.        |
|                                                             |
*----------------Modification Audit/Change Log----------------*
| Rev  Sar                                                    |
| No   Code  Date      Rellvl  Mod  Description               |
| --   ----- --------  ------  ---  --------------------------|
|                                                             |
*-------------------------------------------------------------*/

/*
 * $Log: nexsGraphGeometry.c,v $
 * Revision 1.1  1998/03/23 02:58:36  tkm
 * Initial revision
 *
 */


#include "tclNExSInt.h"

int NExSConnObj_graph_geometry_cmd(
        void *clientData,
        Tcl_Interp *interp,
        int argc,
        char **argv)
{
NExSConnection * conn = (NExSConnection *) clientData;
GrGeometry  ggeom;
unsigned long mask=0;    
int port=0;
int gid=0;


	if (argc < 6 ) { 
		 Tcl_AppendResult( interp,
                "wrong # args: gid x y width height  ", argv[0],
                (char*) NULL);
                return (TCL_ERROR);
	}

	port=conn->port;

	mask = GR_X_POS | GR_Y_POS | GR_WIDTH | GR_HEIGHT;
	Tcl_GetInt(interp, argv[1],&gid);
	Tcl_GetInt(interp, argv[2],&ggeom.x);
	Tcl_GetInt(interp, argv[3],&ggeom.y );
	Tcl_GetInt(interp, argv[4],&ggeom.width);
	Tcl_GetInt(interp, argv[5],&ggeom.height);

	if (nexs_graph_geometry(port, gid, &ggeom, mask)) {
		return TCL_OK;
	}
	return TCL_ERROR; 
}
