static char rcsid[] = "$Id: nexsNameGraph.c,v 1.1 1998/03/23 02:58:36 tkm Exp $";

/*------------------------------------------------------------*
|                                                             |
| Interface for NExS  gtaph API     .                         |
| Author:	Damir Delija                                  |
|               University Computing Center, SRCE             |
| Date:         Wed Mar 12 1997                               |
|               Copyright (c) 1997,  Damir Delija             |
|                                                             |
*--------------------Procedure Description--------------------*
|  nexs_name_graph.c D. Delija 12/03/97                       |
|                                                             |
| int nexs_name(int port, int gid, char *name_buff );         |
|                                                             |
|       Sets the name of the graph specified by "gid"         |
|       to the name contained in "namebuf". If "namebuf"      |
|       is an empty string (length == 0), the existing        |
|       graph name is unchanged. In either case, the          |
|       new (or existing graph name is retrieved into         |
|       "namebuf". Therefore, "namebuf" must point to a       |
|       character array of sufficient size to hold the graph  |
|       name. Note that the name does not take effect on      |
|       the graph window's Motif title bar until the graph    |
|       is redisplayed using nexs_display_graph(). Returns    |
|       1 if successful, 0 otherwise.                         |
|                                                             |
*----------------Modification Audit/Change Log----------------*
| Rev  Sar                                                    |
| No   Code  Date      Rellvl  Mod  Description               |
| --   ----- --------  ------  ---  --------------------------|
|                                                             |
*-------------------------------------------------------------*/

/*
 * $Log: nexsNameGraph.c,v $
 * Revision 1.1  1998/03/23 02:58:36  tkm
 * Initial revision
 *
 */


#include "tclNExSInt.h"

int NExSConnObj_name_graph_cmd(
        void *clientData,
        Tcl_Interp *interp,
        int argc,
        char **argv)
{

NExSConnection * conn = (NExSConnection *) NULL;
int port=0;
int gid=0;
char *name_buff=NULL;


	if (argc < 3 ) { 
		 Tcl_AppendResult( interp,
                "wrong # args: gid name  ", argv[0],
                (char*) NULL);
                return (TCL_ERROR);
	}
	conn = (NExSConnection *) clientData;

	Tcl_GetInt(interp, argv[1],&gid);
	name_buff=argv[2];

	if ( nexs_name_graph( conn->port, gid, name_buff)) {
		return TCL_OK;
	}  
	return TCL_ERROR;



}


