static char rcsid[] = "$Id: nexsPrintGraph.c,v 1.1 1998/03/23 02:58:36 tkm Exp $";

/*------------------------------------------------------------*
|                                                             |
| Interface for NExS  gtaph API     .                         |
| Author:	Damir Delija                                  |
|               University Computing Center, SRCE             |
| Date:         Wed Mar 12 1997                               |
|               Copyright (c) 1997,  Damir Delija             |
|                                                             |
*--------------------Procedure Description--------------------*
| nexs_print_graph.c D. Delija 12/03/97                       |
|                                                             |
| int nexs_print_graph(int port,int gid,int type,char *name); |
|                                                             |
|       Prints the graph specified by "gid" in the format     |
|       specified by "type", which must be one of the         |
|       following values defined in "nexs.h":                 |
|                                                             |
|               GR_EPS          - encapsulated PostScript,    |
|               or GR_IDRAW_PS     - idraw-compatible         |
|               PostScript.                                   |
|                                                             |
|       If "name" is a non-empty string, it is taken to be    |
|       a file name to which the output is to be sent. If     |
|       "name" is empty or NULL, the output is sent to        |
|       the printer, as specified by the "Print Command"      |
|       on the "Printer Characteristics" dialog. Note         |
|       that the graph must be displayed to be printed,       |
|       and that the aspect ratio of the printed graph will   |
|       match the aspect ratio of the graph on the X Window   |
|       display. Returns 1 if successful, 0 otherwise.        |
|                                                             |
*----------------Modification Audit/Change Log----------------*
| Rev  Sar                                                    |
| No   Code  Date      Rellvl  Mod  Description               |
| --   ----- --------  ------  ---  --------------------------|
|                                                             |
*-------------------------------------------------------------*/

/*
 * $Log: nexsPrintGraph.c,v $
 * Revision 1.1  1998/03/23 02:58:36  tkm
 * Initial revision
 *
 */


#include "tclNExSInt.h"

int NExSConnObj_print_graph_cmd(
        void *clientData,
        Tcl_Interp *interp,
        int argc,
        char **argv)
{

NExSConnection * conn = (NExSConnection *) clientData;
int type=GR_EPS;    
char *name=NULL;
int gid=0;

	if (argc <  3 ) { 
		 Tcl_AppendResult( interp,
                "wrong # args: gid eps|idraw_ps file  ", argv[0],
                (char*) NULL);
                return (TCL_ERROR);
	}

	Tcl_GetInt(interp, argv[1],&gid);

	if (argc > 2 ) {
		if (!strcmp(argv[2],"eps")) {
			type=GR_EPS;
		}else
			if (!strcmp(argv[2],"idraw_ps")) {
               			 type=GR_IDRAW_PS;    
        	} 
	}
		

	if (argc > 3 ) {
		name=argv[3];
	}


	if ( nexs_print_graph(conn->port, gid, type, name) ) {
		return TCL_OK;
	}  
	return TCL_ERROR;



}


