static char rcsid[] = "$Id: nexsRedrawGraph.c,v 1.1 1998/03/23 02:58:36 tkm Exp $";

/*------------------------------------------------------------*
|                                                             |
| Interface for NExS  gtaph API     .                         |
| Author:	Damir Delija                                  |
|               University Computing Center, SRCE             |
| Date:         Wed Mar 12 1997                               |
|               Copyright (c) 1997,  Damir Delija             |
|                                                             |
*--------------------Procedure Description--------------------*
| nexs_redraw_graph.c D. Delija 12/03/97                        |
|                                                             |
| int nexs_redraw_graph(int port, int gid);                   |
|                                                             |
| Causes the graph specified by "gid" to be redrawn. This     |
| function would typically be called after changing the       |
| graph's characteristics or data ranges. A graph must be     |
| redrawed before it can be redrawn.                          |
| Returns 1 if successful, 0 otherwise.                       |
|                                                             |
*----------------Modification Audit/Change Log----------------*
| Rev  Sar                                                    |
| No   Code  Date      Rellvl  Mod  Description               |
| --   ----- --------  ------  ---  --------------------------|
|                                                             |
*-------------------------------------------------------------*/

/*
 * $Log: nexsRedrawGraph.c,v $
 * Revision 1.1  1998/03/23 02:58:36  tkm
 * Initial revision
 *
 */


#include "tclNExSInt.h"

int NExSConnObj_redraw_graph_cmd(
        void *clientData,
        Tcl_Interp *interp,
        int argc,
        char **argv)
{

NExSConnection * conn = (NExSConnection *) clientData;
int port=0;
int gid=0;


	if (argc != 2 ) { 
		 Tcl_AppendResult( interp,
                "wrong # args:  ", argv[0],
                (char*) NULL);
                return (TCL_ERROR);
	}

	Tcl_GetInt(interp, argv[1],&gid);


	if (nexs_redraw_graph( conn->port, gid) ) {
		return TCL_OK;
	}  
	return TCL_ERROR;



}


