static char rcsid[] = "$Id: nexsRotateGraph.c,v 1.1 1998/03/23 02:58:36 tkm Exp $";

/*------------------------------------------------------------*
|                                                             |
| Interface for NExS  gtaph API     .                         |
| Author:	Damir Delija                                  |
|               University Computing Center, SRCE             |
| Date:         Wed Mar 12 1997                               |
|               Copyright (c) 1997,  Damir Delija             |
|                                                             |
*--------------------Procedure Description--------------------*
| nexs_rotate_graph.c D. Delija 12/03/97                      |
|                                                             |
| int nexs_rotate_graph(int port, int gid, GrRotate3D         |
| *grotate, int mask);                                        |
|                                                             |
|        Gets and/or sets the rotation angles for the 3-D     |
|        surface graph specified by "gid". See "nexs.h"       |
|        for details on the GrRotate3D structure.             |
|        Returns 1 if successful, 0 otherwise.                |
|                                                             |
*----------------Modification Audit/Change Log----------------*
| Rev  Sar                                                    |
| No   Code  Date      Rellvl  Mod  Description               |
| --   ----- --------  ------  ---  --------------------------|
|                                                             |
*-------------------------------------------------------------*/

/*
 * $Log: nexsRotateGraph.c,v $
 * Revision 1.1  1998/03/23 02:58:36  tkm
 * Initial revision
 *
 */


#include "tclNExSInt.h"

int NExSConnObj_rotate_graph_cmd(
        void *clientData,
        Tcl_Interp *interp,
        int argc,
        char **argv)
{
NExSConnection * conn = (NExSConnection *) clientData;
GrRotate3D grotate;
int mask=0;
int port=0;
int gid=0;
double theta=0;
double phi=0;


	if (argc < 4 ) { 
		 Tcl_AppendResult( interp,
                "wrong # args: gid theta phi  ", argv[0],
                (char*) NULL);
                return (TCL_ERROR);
	}
	port=conn->port;
	mask = THETA | PHI;
	Tcl_GetInt(interp, argv[1],&gid);

	Tcl_GetDouble(interp, argv[2], &theta);
	Tcl_GetDouble(interp, argv[3], &phi);
	grotate.theta=(float)theta;
	grotate.phi=(float)phi;

	if ( nexs_rotate_graph(port,gid, &grotate,mask) ) {
		return TCL_OK;
	}  
	return TCL_ERROR;

}

